Page MenuHomePhabricator

Structured tasks: confirmation dialog when exit out of suggestion mode prior to making changes
Closed, ResolvedPublic

Assigned To
Authored By
RHo
Jan 31 2022, 10:16 PM
Referenced Files
F34975401: Desktop-history-view-edit.webm
Mar 4 2022, 6:45 PM
F34975396: image.png
Mar 4 2022, 6:45 PM
F34970393: Kapture 2022-02-28 at 13.02.21.webm
Feb 28 2022, 8:55 PM
F34970392: Mobile-animation-post-edit-dialog.webm
Feb 28 2022, 8:55 PM
F34951743: leaveWarning_2a.gif
Feb 14 2022, 9:45 PM
F34951750: leaveWarning_2b_mobile.gif
Feb 14 2022, 9:45 PM
F34951747: leaveWarning_2b.gif
Feb 14 2022, 9:45 PM
F34951745: leaveWarning_2a_mobile.gif
Feb 14 2022, 9:45 PM

Description

Note: this task is recreated from T300571 after it was pointed out this was not a bug.

Currently in the "add a link" and "add an image" task on mobile, if the user presses the close button on the toolbar or switches to the VE editor before accepting the single image suggestion, no warning confirmation is provided. This may lead to a high abandonment on tasks since it may not be clear to users who how to return to the task if they pressed either exit unwittingly.

Current behaviour
1/ Open a task
2a/ Go to the editor dropdown and switch the editor mode to Visual Editor;
OR
2b/ Close the task using the close icon on the top left of the Suggested editor toolbar.

After 2a --> the user is switched to the Visual Editor mode straightaway
After 2b --> the user is switched to the Reading mode of the article straightaway

Proposed change:
In 2a, the user sees the edit mode switch confirmation dialog first that they would see if some change was made to the UI (per T269653).
In 2b, the user sees the abandonedit dialog.

Software version (if not a Wikimedia wiki), browser information, screenshots, other information, etc.:
cs beta
test wiki

Event Timeline

If the concern is the user not finding their way back, I wonder if a one-time guider pointing to the edit link would be a better solution than a confirmation dialog? (A bit more effort though.)

One of the other ways when a user can get lost (not be able to return to the Suggestions mode) would be switching between Read and View history tabs. The Suggestions surface will not be present when a user clicks on the Edit tab. The issue is not straightforwardly reproducible; a user should repeatedly go between Read, View history and Edit tabs.

MMiller_WMF renamed this task from Add image: Add a confirmation dialog when the user selects to switch or exit out of Add image suggestion mode prior to making changes to Structured tasks: confirmation dialog whenexit out of suggestion mode prior to making changes.Feb 12 2022, 1:09 AM
MMiller_WMF renamed this task from Structured tasks: confirmation dialog whenexit out of suggestion mode prior to making changes to Structured tasks: confirmation dialog when exit out of suggestion mode prior to making changes.
MMiller_WMF updated the task description. (Show Details)
MMiller_WMF edited projects, added Growth-Team (Current Sprint); removed Growth-Team.

Hi @RHo, for 2b, should we use a different confirmation message since the user is essentially switching to read mode but the message specifically mentions making edits?

Screen Shot 2022-02-14 at 9.44.44 AM.png (590×622 px, 62 KB)

Another option might be to use the default abandonedit dialog but it might be odd since there is nothing to publish.

Screen Shot 2022-02-14 at 9.48.06 AM.png (408×624 px, 54 KB)

Hi @RHo, for 2b, should we use a different confirmation message since the user is essentially switching to read mode but the message specifically mentions making edits?

Screen Shot 2022-02-14 at 9.44.44 AM.png (590×622 px, 62 KB)

Another option might be to use the default abandonedit dialog but it might be odd since there is nothing to publish.

Screen Shot 2022-02-14 at 9.48.06 AM.png (408×624 px, 54 KB)

Thanks for thinking about this further @mewoph - I think abandonededit makes more sense.

Here are the dialogs shown when the user hasn't made any edits.

2a (desktop)

leaveWarning_2a.gif (1×1 px, 1 MB)

2a (mobile)

leaveWarning_2a_mobile.gif (1×750 px, 565 KB)

2b (desktop)

leaveWarning_2b.gif (1×1 px, 1 MB)

2b (mobile)

leaveWarning_2b_mobile.gif (1×750 px, 521 KB)

Change 762547 had a related patch set uploaded (by MewOphaswongse; author: MewOphaswongse):

[mediawiki/extensions/GrowthExperiments@master] Structured tasks: Show confirmation dialog when leaving suggestions mode regardless of whether the user has made any edits

https://gerrit.wikimedia.org/r/762547

@RHo @nettrom_WMF just to double-check, do you want the abandonedit dialog (impression, and "continue editing" and "discard edits" buttons) to be instrumented?

@kostajh : Since we have the switch dialogue instrumented, and the investigation into the tagged non-image edits found users switching to VE mode, I think we should have the abandonedit dialogue instrumented as well. I think it'll be useful in the funnel analysis of desktop Add an Image down the line (I'm already working on the mobile one), or for investigations if we see something come up again like we did previously.

Change 762898 had a related patch set uploaded (by MewOphaswongse; author: MewOphaswongse):

[schemas/event/secondary@master] Structured task: add abandonedit_dialog active_interface and its actions

https://gerrit.wikimedia.org/r/762898

Sample payload:

Dialog shown (action="impression")

event: {
  "action": "impression",
  "action_data": "",
  "is_mobile": false,
  "newcomer_task_token": "2dgsiiqmfmonhbkd59hier954qkhhi59",
  "page_id": 1753,
  "page_title": "Vombat obecný",
  "homepage_pageview_token": "2takidbq40fv24jsvd40r1m1qu35b6pl",
  "active_interface": "abandonedit_dialog",
  "$schema": "/analytics/mediawiki/structured_task/article/link_suggestion_interaction/1.5.0",
  "meta": {
    "stream": "mediawiki.structured_task.article.link_suggestion_interaction",
    "domain": "localhost",
    "id": "f0eedf3d-d83c-4a4e-b043-14298851d51b",
    "dt": "2022-02-15T18:35:25.155Z",
    "request_id": "0a558600-8e8e-11ec-85f9-37dda4ee9bac"
  },
  "dt": "2022-02-15T18:35:24.148Z",
  "http": {
    "request_headers": {
      "user-agent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/98.0.4758.80 Safari/537.36"
    },
    "client_ip": "127.0.0.1"
  }
}

Continue editing (action="keep")

event: {
  "action": "keep",
  "action_data": "",
  "is_mobile": false,
  "newcomer_task_token": "2dgsiiqmfmonhbkd59hier954qkhhi59",
  "page_id": 1753,
  "page_title": "Vombat obecný",
  "homepage_pageview_token": "2takidbq40fv24jsvd40r1m1qu35b6pl",
  "active_interface": "abandonedit_dialog",
  "$schema": "/analytics/mediawiki/structured_task/article/link_suggestion_interaction/1.5.0",
  "meta": {
    "stream": "mediawiki.structured_task.article.link_suggestion_interaction",
    "domain": "localhost",
    "id": "1abb5837-3ff1-48b7-b2a8-1a2bd622f444",
    "dt": "2022-02-15T18:37:05.178Z",
    "request_id": "45f42090-8e8e-11ec-85f9-37dda4ee9bac"
  },
  "dt": "2022-02-15T18:37:04.173Z",
  "http": {
    "request_headers": {
      "user-agent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/98.0.4758.80 Safari/537.36"
    },
    "client_ip": "127.0.0.1"
  }
}

Discard edits (action="discard")

event: {
  "action": "discard",
  "action_data": "",
  "is_mobile": false,
  "newcomer_task_token": "2dgsiiqmfmonhbkd59hier954qkhhi59",
  "page_id": 1753,
  "page_title": "Vombat obecný",
  "homepage_pageview_token": "2takidbq40fv24jsvd40r1m1qu35b6pl",
  "active_interface": "abandonedit_dialog",
  "$schema": "/analytics/mediawiki/structured_task/article/link_suggestion_interaction/1.5.0",
  "meta": {
    "stream": "mediawiki.structured_task.article.link_suggestion_interaction",
    "domain": "localhost",
    "id": "e9db395c-ddb1-4b23-b7c0-a4be2d8d5bde",
    "dt": "2022-02-15T18:37:26.201Z",
    "request_id": "527bfb80-8e8e-11ec-85f9-37dda4ee9bac"
  },
  "dt": "2022-02-15T18:37:25.197Z",
  "http": {
    "request_headers": {
      "user-agent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/98.0.4758.80 Safari/537.36"
    },
    "client_ip": "127.0.0.1"
  }
}

Change 762898 merged by jenkins-bot:

[schemas/event/secondary@master] Structured task: add abandonedit_dialog active_interface and its actions

https://gerrit.wikimedia.org/r/762898

kostajh triaged this task as Medium priority.Feb 15 2022, 8:28 PM
kostajh moved this task from Code Review to QA on the Growth-Team (Current Sprint) board.

Change 762547 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] Structured tasks: Show confirmation dialog when leaving suggestions mode regardless of whether the user has made any edits

https://gerrit.wikimedia.org/r/762547

Checked on testwiki wmf.23.
From the task description it seems that the confirmation dialog or abandonit dialog would be shown if some change was made to the UI

Proposed change:
In 2a, the user sees the edit mode switch confirmation dialog first that they would see if some change was made to the UI (per T269653). In 2b, the user sees the abandonedit dialog.

The current behavior doesn't differentiate between when some edits were made or there were no edits.
for @RHo review to confirm that the current behavior is ok:

(1) Both dialogs assume that some edits were made. @mewoph comments mentioned that, probably, for the case when no edits are made, it would look odd,

(2) The wording of abandonit dialog refers to "editing mode" when, in fact, a user is leaving Suggestions mode.

Screen Shot 2022-02-14 at 9.48.06 AM.png (408×624 px, 54 KB)

(3) the confirmation dialog refers to "switching modes" - would it be understood by newcomers what modes they are switching? The name "Visual editing" probably would be easier to understood since it's self-explanatory, e.g. "Switching to Visual editing will allow you..."

Screen Shot 2022-02-14 at 9.44.44 AM.png (590×622 px, 62 KB)

(4) (desktop) I re-checked the case described in my comment - https://phabricator.wikimedia.org/T300582#7666038.
The steps to reproduce the issue:

  • a user goes to a structured task article
  • without any interaction (with the add link inspector or add image card), clicks on History tab, then on View tab - then, when clicking on Edit tab a user won't see the Suggestions surface at all.

Hi @Etonkovidova, (4) sounds like a separate issue to me, that the suggestions mode is not shown (this task only adds the dialog to the two cases mentioned in the task description). Can you file a separate task? Thank you!

This comment was removed by RHo.

Checked on testwiki wmf.23.
From the task description it seems that the confirmation dialog or abandonit dialog would be shown if some change was made to the UI

Thanks @Etonkovidova – to clarify/confirm your tests, this task is about showing the confirmation dialog in scenario 2a or abandonit in 2b even when no change has been made to the UI, as an added step to prevent users accidentally exiting out of the Suggestions mode as it is not clear after exiting how they would go back to that suggestion.
Have a couple of comments on each scenario below but overall this LGTM!

Proposed change:
In 2a, the user sees the edit mode switch confirmation dialog first that they would see if some change was made to the UI (per T269653). In 2b, the user sees the abandonedit dialog.

The current behavior doesn't differentiate between when some edits were made or there were no edits.
for @RHo review to confirm that the current behavior is ok:

(1) Both dialogs assume that some edits were made. @mewoph comments mentioned that, probably, for the case when no edits are made, it would look odd,

Yes, this is fine. I think the body copy referring to being sure they "Finish reviewing" is general enough even if the user had not accepted any link/image suggestion yet.

image.png (732×744 px, 94 KB)

(2) The wording of abandonit dialog refers to "editing mode" when, in fact, a user is leaving Suggestions mode.

Screen Shot 2022-02-14 at 9.48.06 AM.png (408×624 px, 54 KB)

I think this is ok too as Suggestions mode is technically and an editing mode same as Visual Editor and Wikitext (and differentiated from "Read" mode :)).

(3) the confirmation dialog refers to "switching modes" - would it be understood by newcomers what modes they are switching? The name "Visual editing" probably would be easier to understood since it's self-explanatory, e.g. "Switching to Visual editing will allow you..."

Screen Shot 2022-02-14 at 9.44.44 AM.png (590×622 px, 62 KB)

Agree but think we may also want to keep it generic enough for if and when we will enable switching to Wikitext mode too.

(4) (desktop) I re-checked the case described in my comment - https://phabricator.wikimedia.org/T300582#7666038.
The steps to reproduce the issue:

  • a user goes to a structured task article
  • without any interaction (with the add link inspector or add image card), clicks on History tab, then on View tab - then, when clicking on Edit tab a user won't see the Suggestions surface at all.

! In T300582#7742055, @mewoph wrote:

Hi @Etonkovidova, (4) sounds like a separate issue to me, that the suggestions mode is not shown (this task only adds the dialog to the two cases mentioned in the task description). Can you file a separate task? Thank you!

Agree with @mewoph that this is a separate issue which seems to be fixed now?